NOTICE = 0
WARNING = 1
ERROR = 2

errors = {}
options = {}
__all__ = ["NOTICE", "WARNING", "ERROR"]



options[254] = "accept_lic"; accept_lic = 254L
options[253] = "install_loc"; install_loc = 253L
options[252] = "url_net"; url_net = 252L
options[251] = "username"; username = 251L
options[250] = "dbname"; dbname = 250L
options[249] = "instance_pass1"; instance_pass1 = 249L
options[248] = "url_path"; url_path = 248L
options[247] = "backup_loc"; backup_loc = 247L

MUST_ACCEPT_LICENSE = (57L << 56) | (accept_lic << 48) | 999; errors[(57L << 56) | (accept_lic << 48) | 999] = "The license agreement must be accepted in order to install this software."; __all__.append("MUST_ACCEPT_LICENSE")
INVALID_URL_LOCATION = (57L << 56) | (url_net << 48) | 998; errors[(57L << 56) | (url_net << 48) | 998] = "The URL location http://%(url_net)s/%(url_path)s could not be resolved to a path within the site."; __all__.append("INVALID_URL_LOCATION")
UNPACK_OVER_EXISTING_FILES = (57L << 56) | (install_loc << 48) | 997; errors[(57L << 56) | (install_loc << 48) | 997] = "The following files already exist under the specified install location (if '...' appears at the end of the list, additional conflicts exist beyond those shown): %(files)s."; __all__.append("UNPACK_OVER_EXISTING_FILES")
DIR_OWNER_MISMATCH = (57L << 56) | (username << 48) | 996; errors[(57L << 56) | (username << 48) | 996] = "The install location %(install_loc)s already exists, and is owned by the user %(owner)s. The tool owner and install location owner must match."; __all__.append("DIR_OWNER_MISMATCH")
DIR_GROUP_MISMATCH = (57L << 56) | (username << 48) | 995; errors[(57L << 56) | (username << 48) | 995] = "The install location %(install_loc)s already exists, and is owned by the group %(group)s. The tool owner's group and install location group must match."; __all__.append("DIR_GROUP_MISMATCH")
URL_LOC_NEED_SUBDIRECTORY = (57L << 56) | (url_path << 48) | 994; errors[(57L << 56) | (url_path << 48) | 994] = "You must provide a subdirectory under /var/www."; __all__.append("URL_LOC_NEED_SUBDIRECTORY")
ADMIN_HOME_INSTALLATION = (57L << 56) | (username << 48) | 993; errors[(57L << 56) | (username << 48) | 993] = "Installations are not allowed in the site administrator's home directory."; __all__.append("ADMIN_HOME_INSTALLATION")
DATABASE_EXISTS = (57L << 56) | (dbname << 48) | 992; errors[(57L << 56) | (dbname << 48) | 992] = "The database %(dbname)s already exists."; __all__.append("DATABASE_EXISTS")
PASSWORD_MISMATCH = (57L << 56) | (instance_pass1 << 48) | 991; errors[(57L << 56) | (instance_pass1 << 48) | 991] = "The passwords entered for the application administrator do not match."; __all__.append("PASSWORD_MISMATCH")
MISSING_URL_NET = (57L << 56) | (url_net << 48) | 990; errors[(57L << 56) | (url_net << 48) | 990] = "Missing path specifier (url_net)."; __all__.append("MISSING_URL_NET")
MISSING_URL_PATH = (57L << 56) | (url_path << 48) | 989; errors[(57L << 56) | (url_path << 48) | 989] = "Missing path specifier (url_path)."; __all__.append("MISSING_URL_PATH")
NO_BACKUP_LOC = (57L << 56) | (backup_loc << 48) | 988; errors[(57L << 56) | (backup_loc << 48) | 988] = "You must specify a backup location and prefix."; __all__.append("NO_BACKUP_LOC")
BACKUP_LOC_NOT_ABSOLUTE = (57L << 56) | (backup_loc << 48) | 987; errors[(57L << 56) | (backup_loc << 48) | 987] = "The backup location must start with an absolute path."; __all__.append("BACKUP_LOC_NOT_ABSOLUTE")
BACKUP_LOC_MISSING = (57L << 56) | (backup_loc << 48) | 986; errors[(57L << 56) | (backup_loc << 48) | 986] = "The path %(backup_dir)s to the backup location does not exist."; __all__.append("BACKUP_LOC_MISSING")

MYSQL_NOT_ENABLED = ((57L << 56) | (255L << 48)) | 999; errors[((57L << 56) | (255L << 48)) | 999] = "MySQL must be enabled in order to install this package."; __all__.append("MYSQL_NOT_ENABLED")
DATABASE_CREATION_FAILED = ((57L << 56) | (255L << 48)) | 998; errors[((57L << 56) | (255L << 48)) | 998] = "Failed to create database %(dbname)s. Return code: %(ret)s."; __all__.append("DATABASE_CREATION_FAILED")
UNPACKING_ARCHIVE_FAILED = ((57L << 56) | (255L << 48)) | 997; errors[((57L << 56) | (255L << 48)) | 997] = "The source archive could not be unpacked successfully."; __all__.append("UNPACKING_ARCHIVE_FAILED")
INSTALL_URL = ((57L << 56) | (255L << 48)) | 996; errors[((57L << 56) | (255L << 48)) | 996] = "Please go to %(url)s to finish the installation."; __all__.append("INSTALL_URL")
INSTALL_LOC = ((57L << 56) | (255L << 48)) | 995; errors[((57L << 56) | (255L << 48)) | 995] = "Please access %(file)s via your browser to finish the installation."; __all__.append("INSTALL_LOC")
INSTALL_LOCATION_CHANGE = ((57L << 56) | (255L << 48)) | 994; errors[((57L << 56) | (255L << 48)) | 994] = "The installation location can not be changed."; __all__.append("INSTALL_LOCATION_CHANGE")
USERNAME_CHOWN_FAILED = ((57L << 56) | (255L << 48)) | 993; errors[((57L << 56) | (255L << 48)) | 993] = "An error occured while changing the ownership of the files."; __all__.append("USERNAME_CHOWN_FAILED")
CHANGE_DATABASE_FAILED = ((57L << 56) | (255L << 48)) | 992; errors[((57L << 56) | (255L << 48)) | 992] = "An error occurred while renaming the database."; __all__.append("CHANGE_DATABASE_FAILED")
ACCESS_URL = ((57L << 56) | (255L << 48)) | 991; errors[((57L << 56) | (255L << 48)) | 991] = "You may now access your installation by going to %(url)s."; __all__.append("ACCESS_URL")
MYSQL_DB_PROBE_FAILED = ((57L << 56) | (255L << 48)) | 990; errors[((57L << 56) | (255L << 48)) | 990] = "Unable to log in to the MySQL database: %(msg)s."; __all__.append("MYSQL_DB_PROBE_FAILED")
MYSQL_SQL_FAILED = ((57L << 56) | (255L << 48)) | 989; errors[((57L << 56) | (255L << 48)) | 989] = "The SQL query %(sql)s failed: %(msg)s."; __all__.append("MYSQL_SQL_FAILED")
MYSQL_NOT_INSTALLED = ((57L << 56) | (255L << 48)) | 988; errors[((57L << 56) | (255L << 48)) | 988] = "The MySQL module is not installed on this appliance."; __all__.append("MYSQL_NOT_INSTALLED")

USER_QUOTA_EXHAUSTED = ((57L << 56) | (255L << 48)) | 987; errors[((57L << 56) | (255L << 48)) | 987] = "This user has no disk quota left."; __all__.append("USER_QUOTA_EXHAUSTED")
GROUP_QUOTA_EXHAUSTED = ((57L << 56) | (255L << 48)) | 986; errors[((57L << 56) | (255L << 48)) | 986] = "This site has no disk quota left."; __all__.append("GROUP_QUOTA_EXHAUSTED")
QUOTA_ERROR = ((57L << 56) | (255L << 48)) | 985; errors[((57L << 56) | (255L << 48)) | 985] = "There was an error while retrieving the quota information."; __all__.append("QUOTA_ERROR")
ACCESS_URL_WITH_NAME = ((57L << 56) | (255L << 48)) | 984; errors[((57L << 56) | (255L << 48)) | 984] = "You may now access your installation by going to %(url)s. The initial login name is %(user)s."; __all__.append("ACCESS_URL_WITH_NAME")
MYSQL_DATABASE_LIMIT = ((57L << 56) | (255L << 48)) | 983; errors[((57L << 56) | (255L << 48)) | 983] = "The maximum number of MySQL databases for this site has been exceeded."; __all__.append("MYSQL_DATABASE_LIMIT")
ALT_INDEX_EXISTS = ((57L << 56) | (255L << 48)) | 982; errors[((57L << 56) | (255L << 48)) | 982] = "An alternative index file %(index)s exists in the specified installation location. This may prevent you from reaching this application's index page unless you specify the entire URL."; __all__.append("ALT_INDEX_EXISTS")
PHP_SCRIPT_FAILED = ((57L << 56) | (255L << 48)) | 981; errors[((57L << 56) | (255L << 48)) | 981] = "Executing PHP script %(script)s failed."; __all__.append("PHP_SCRIPT_FAILED")
PATCH_WARNING = ((57L << 56) | (255L << 48)) | 980; errors[((57L << 56) | (255L << 48)) | 980] = "The following message was received while applying the patch %(patch)s: %(output)s."; __all__.append("PATCH_WARNING")
PASSWORD_EMPTY = ((57L << 56) | (255L << 48)) | 979; errors[((57L << 56) | (255L << 48)) | 979] = "Password for the application administrator can not be empty."; __all__.append("PASSWORD_EMPTY")
INVALID_PATH = ((57L << 56) | (255L << 48)) | 978; errors[((57L << 56) | (255L << 48)) | 978] = "Install location should not contain relative pathnames."; __all__.append("INVALID_PATH")
MKDIR_FAILED = ((57L << 56) | (255L << 48)) | 977; errors[((57L << 56) | (255L << 48)) | 977] = "Unable to create the directory %(dir)s. Error %(errno)d: %(errstr)s."; __all__.append("MKDIR_FAILED")
BAD_ARCHIVE_TYPE = ((57L << 56) | (255L << 48)) | 976; errors[((57L << 56) | (255L << 48)) | 976] = "The archive type %(type)s is not recognized."; __all__.append("BAD_ARCHIVE_TYPE")
SOURCE_PATCH_FAILED = ((57L << 56) | (255L << 48)) | 975; errors[((57L << 56) | (255L << 48)) | 975] = "The patch %(patch)s did not apply cleanly."; __all__.append("SOURCE_PATCH_FAILED")
RENAME_FAILED = ((57L << 56) | (255L << 48)) | 974; errors[((57L << 56) | (255L << 48)) | 974] = "Failed to rename %(src)s to %(dst)s. Error %(errno)d: %(errstr)s."; __all__.append("RENAME_FAILED")
CHOWN_FAILED = ((57L << 56) | (255L << 48)) | 973; errors[((57L << 56) | (255L << 48)) | 973] = "Failed to change the ownership of the file %(path)s to (%(uid)d, %(gid)d). Error %(errno)d: %(errstr)s."; __all__.append("CHOWN_FAILED")
CHMOD_FAILED = ((57L << 56) | (255L << 48)) | 972; errors[((57L << 56) | (255L << 48)) | 972] = "Failed to change the permissions of the file %(path)s to %(perms)o. Error %(errno)d: %(errstr)s."; __all__.append("CHMOD_FAILED")
DEFAULT_DSPADMIN = ((57L << 56) | (255L << 48)) | 971; errors[((57L << 56) | (255L << 48)) | 971] = "Default Adiministrator for %(dsp_name)s is %(admin_user)s with password %(admin_pass)s"; __all__.append("DEFAULT_DSPADMIN")
BACKUP_FILES_FAILED = ((57L << 56) | (255L << 48)) | 970; errors[((57L << 56) | (255L << 48)) | 970] = "The backup of the tool files failed. Exit code %(errno)d. Standard Error: %(stderr)s."; __all__.append("BACKUP_FILES_FAILED")
BACKUP_DB_FAILED = ((57L << 56) | (255L << 48)) | 970; errors[((57L << 56) | (255L << 48)) | 970] = "The backup of the tool database failed. Exit code %(errno)d. Standard Error: %(stderr)s."; __all__.append("BACKUP_DB_FAILED")
