<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:import href="/usr/lib/ensim/deployables/lib/themes/default.xsl"/>
  <xsl:output method="text" omit-xml-declaration="yes"/>

  <xsl:variable name="newline">
<xsl:text>
</xsl:text>
  </xsl:variable>

  <xsl:template match="/">
    <xsl:if test="dsp/@context='auto_upgrade'">
      <xsl:apply-templates select="dsp/dspDescription"/>
    </xsl:if>
    <xsl:apply-templates select="dsp/msgs/msg"/>
  </xsl:template>

  <xsl:template match="dspDescription">
    <xsl:call-template name="gettext">
      <xsl:with-param name="default" select="'Upgrading: '"/>
    </xsl:call-template>
    <xsl:value-of select="normalize-space(longname)"/>
    <xsl:text> </xsl:text>
    <xsl:value-of select="normalize-space(version)"/>
    <xsl:text> (</xsl:text>
    <xsl:value-of select="normalize-space(upgradeFrom/dapiversion)"/>
    <xsl:text>-</xsl:text>
    <xsl:value-of select="normalize-space(upgradeFrom/dapirelease)"/>
    <xsl:text>) - (</xsl:text>
    <xsl:value-of select="normalize-space(dapiversion)"/>
    <xsl:text>-</xsl:text>
    <xsl:value-of select="normalize-space(dapirelease)"/>
    <xsl:text>) </xsl:text>
    <xsl:call-template name="gettext">
      <xsl:with-param name="default" select="'Instance ID '"/>
    </xsl:call-template>
    <xsl:value-of select="@instance_id"/>
    <xsl:value-of select="$newline"/>
  </xsl:template>

  <xsl:template match="msg">
    <xsl:choose>
      <xsl:when test="number(@severity) = 0">
        <xsl:text>(NOTICE:  </xsl:text>
      </xsl:when>
      <xsl:when test="number(@severity) = 1">
        <xsl:text>(WARNING: </xsl:text>
      </xsl:when>
      <xsl:when test="number(@severity) = 2">
        <xsl:text>(ERROR:   </xsl:text>
      </xsl:when>
    </xsl:choose>
    <xsl:value-of select="string(@code)"/>
    <xsl:text>) </xsl:text>
    <xsl:if test="@option">
      <xsl:text>'</xsl:text>
      <xsl:value-of select="@option"/>
      <xsl:text>'</xsl:text>
    </xsl:if>
    <xsl:text>: </xsl:text>
    <xsl:value-of select="normalize-space(string)"/>
    <xsl:value-of select="$newline"/>
  </xsl:template>
</xsl:stylesheet>
