#!/usr/bin/eperl -w
#
# Copyright (c) Ensim Corporation, 1999   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
# Exit codes (on failure error message goes to stderr):
#  0 - success
#  1 - failure
# 
# Boolean arguments on the command line are given as 0 or 1. All the
# command line arguments are encoded to avoid problems with escapes.


use lib "/usr/lib/opcenter/base";
push @INC, (($ENV{'OCW_SVCPATH'} || "/usr/lib/opcenter") . "/apache");
push @INC, ($ENV{'OCW_SVCPATH'} || "/usr/lib/opcenter")."/cmdline_common";

use lib ($ENV{OCW_SVCPATH} or "/usr/lib/opcenter") . "/apache";
use lib ($ENV{OCW_SVCPATH} or "/usr/lib/opcenter") . "/cmdline_common";

use ERRORS;
use Carper;
use POSIX qw(tmpnam);
use File::Copy;

if(@ARGV < 2)
{
    $cerr += $E_ARG;
	print("The number of arguments is wrong.\n");
	print("Usage:\nRepairhtaccess <htaccess file path> <htgroup file path> [<user>]\n");
	exit(1);
}
my($temp_filename) = tmpnam();
my($error_message) = &Repairhtaccess($temp_filename);

if ($error_message eq "") {
  # note here i still have dropped privs
  copy($ARGV[0], $ARGV[0] . ".bak");
  copy($temp_filename, $ARGV[0]);
  unlink($temp_filename);
}


if ($error_message) 
{
  	print STDERR $error_message;
  	exit 1;
}
exit 0;

#####################################
sub check_authname
{
    $string = $_[0];
    $bpresent = $string =~ /AuthName/;
    if($bpresent == 1)
    {
        $bpresent = $string =~/\"/;
        if($bpresent == 0)
        {
            $szAuthName = "AuthName";
            $string =~ s/AuthName//;
            chomp($string);
            $szAuthName = $szAuthName . " \"" . $string . "\"" . "\n";
            return $szAuthName;
        }
    }
    return $string;
}
#####################################
sub check_doublequotes
{
    $string = $_[0];
    $string =~ s/\"\"/\"/g;
    return $string
    
}
#####################################
sub Repairhtaccess
{ # recover the apache file
	my($htaccess) = $ARGV[ 0 ]; # ".htaccess"; # get the file name
	my($htgroup)  = $ARGV[ 1 ]; # "htgroup"; # get the file name
			   	    # print ("htgroup= $htgroup htaccess= $htaccess\n"); 
	my($tmpfilename) = @_;
	if($#ARGV == 2) {
	    # Assume user privileges
	    my($user, $passwd, $uid, $gid, $quota, $comment, $gcos, $dir, $shell) = getpwnam($ARGV[2]);
	    $) = $gid;
	    $> = $uid;
	}

	open(tmpfile_ptr,">$tmpfilename");

	my($data, $data1, $data2, $data3, $data4, $data5, $data6, $bPresent, $bfound);
	unless( open(hHtAccess, $htaccess) )
	{ 
        $cerr += $E_HTACCESS ;
                close(tmpfile_ptr);
	        unlink $tmpfilename;
		return ("Failed to open .htaccess file.");
	}
	unless( open(hHtGroup, $htgroup) )
	{
        $cerr += $E_HTGROUP ;
                close(tmpfile_ptr);
	        unlink $tmpfilename;
		return ("Failed to open htgroup file.");
	}
	$bfound = 0;
	$data2 = "";
req:	while($data2 = <hHtAccess>)
	{
        $data2 = check_doublequotes($data2);
        $data2 = check_authname($data2);

		$data1 = $data2 =~ /require/;
		if($data1 != 0)
		{
			$bfound = 1;
			last req;
		}
		else
		{
			print tmpfile_ptr $data2;
		}
	}
	if($bfound == 0)
	{ # case where the repair is not reqd
	        close(tmpfile_ptr);
		return "";
	}
	$data5 = "require group " ;
	while($data = <hHtGroup>)
	{
		$data1 = $data2 =~ /require/;
		$data3 = index($data, ":") ;
		$data4 = substr($data, 0, $data3);
		$data6 = $data2 =~ /$data4/;
		if($data1 && $data6)
		{
			# kept for debugging
			# print("data1=$data1, data4 = $data4 data6 = $data6 data2 = $data2\n");	
			$bPresent = 1;
			$data5 = "$data5" . "$data4" . " ";
		}
	}
	print tmpfile_ptr $data5 . "\n";
	close(hHtGroup);
	while($data2 = <hHtAccess>)
	{
		print tmpfile_ptr $data2;
	}
	close(hHtAccess);
	if($bPresent)
	{
                close(tmpfile_ptr);
		return "";
	}
	else
	{
        $cerr += $E_NOGROUPMATCH;
		return ("Error: Groups do not match the groups in .htaccess. Unprotect the directory and protect the directory again");
	}
}
#####################################

