# --------------------------------------------------------------------------
###
#
# Copyright (c) Ensim Corporation 2000, 2001   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
# Exit codes (on failure error message goes to stderr):
#  0 - success
#  1 - failure
# 
# Boolean arguments on the command line are given as 0 or 1. All the
# command line arguments are encoded to avoid problems with escapes.
#
# All functions defined here either return an error message if an
# error occured and "" if everything went well or allways return a
# valid value, but exit (with code 1) printing an error message if an
# error occurs. This second type of functions have _e appended to
# their name. Functions are allowed to print results onto stdout, but
# errors are printed only in the main program.
# --------------------------------------------------------------------------
# $Id: SSLconf.pm,v 1.9 2001/06/23 02:47:14 agupta Exp $
# $Name:  $
# --------------------------------------------------------------------------

package SSLconf;

BEGIN { }

END { }

if ($ENV{'OSTYPE'} =~ /^solaris/i) {
#    $config{'command'}      = "/usr/local/ssl/bin/sslccert";
#    $config{'key_command'}  = "/usr/local/ssl/bin/sslckey";
#    $config{'conf_file'}    = "/usr/local/ssl/lib/sslc.cnf";

    $config{'command'}      = "/usr/bin/openssl";
    $config{'key_command'}  = "/usr/bin/openssl";
    $config{'conf_file'}    = "/usr/local/ssl/openssl.cnf";

    $config{'cert_file'}    = "/usr/local/apache/conf/ssl.crt/server.crt";
    $config{'req_file'}     = "/usr/local/apache/conf/ssl.csr/server.csr";
    $config{'key_file'}     = "/usr/local/apache/conf/ssl.key/server.key";
} else {
#    $config{'command'}      = "/usr/local/ssl/bin/sslccert";
#    $config{'key_command'}  = "/usr/local/ssl/bin/sslckey";
#    $config{'conf_file'}    = "/usr/local/ssl/lib/sslc.cnf";

    $config{'command'}      = "/usr/bin/openssl";
    $config{'key_command'}  = "/usr/bin/openssl";
    $config{'conf_file'}    = "/usr/share/ssl/openssl.cnf";

    $config{'cert_file'}    = "/etc/httpd/conf/ssl.crt/server.crt";
    $config{'req_file'}     = "/etc/httpd/conf/ssl.csr/server.csr";
    $config{'key_file'}     = "/etc/httpd/conf/ssl.key/server.key";
}

return 1;

