# --------------------------------------------------------------------------
###
#
# Copyright (c) Ensim Corporation 2000, 2001   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
# Exit codes (on failure error message goes to stderr):
#  0 - success
#  1 - failure
# 
# Boolean arguments on the command line are given as 0 or 1. All the
# command line arguments are encoded to avoid problems with escapes.
#
# All functions defined here either return an error message if an
# error occured and "" if everything went well or allways return a
# valid value, but exit (with code 1) printing an error message if an
# error occurs. This second type of functions have _e appended to
# their name. Functions are allowed to print results onto stdout, but
# errors are printed only in the main program.
#
###

# Copyright (c) Ensim Corporation 2000, 2001
# ENSIM CORPORATION - ALL RIGHTS RESERVED
# --------------------------------------------------------------------------
# $Id: ds.pm,v 1.3 2001/03/16 22:14:53 uday Exp $
# $Name:  $
# --------------------------------------------------------------------------
package ds;

sub printString {
  local($s)=@_;
  print "String:$s\n";
}

sub printHash {
  local($h) = @_;
  local($key);
  print("Hash:eoh\n"); 
  foreach $key (keys(%$h)) {
    &printString($key);
    &printDS($h->{$key});
  } 
  print("eoh\n"); 
}

sub printArray {
  local($a) = @_;
  print("Array:eoa\n"); 
  for (local($i)=0; $i <= $#$a; $i++) {
    &printDS($$a[$i]);  
  } 
  print("eoa\n"); 
}

sub printDS {
  local($ds) = @_;
  if ( ref($ds) eq 'ARRAY') {
    &printArray($ds);
  } elsif ( ref($ds) eq 'HASH') {
    &printHash($ds);
  } else {
    &printString($ds);
  }
}

return 1;
