package DnsUpdateResult;

use strict;

sub new () {
    my $class = shift;
    my $self  = {};

    bless $self, $class;
    $self->_init (@_);
    
    return $self;
}

sub status {
    my $self = shift;
    return $self->{status};
}

sub update {
    my $self = shift;
    return $self->{update};
}

sub zone {
    my $self = shift;
    return $self->{zone};
}

sub master {
    my $self = shift;
    return $self->{zone};
}

sub _init { 
    my $self = shift;
    my $zone = shift;
    my $master = shift;
    my $header = shift;

    $self->{zone} = $zone;
    $self->{master} = $master;

    # parse reply header
    foreach my $line (@{$header}) {
	$line = substr ($line, 3);
	
	my @attrs = split /[,|;|:] /, $line;

	for (my $i=0 ; $i < scalar (@attrs) ; $i+=2) {
	    $attrs[$i] =~ s/^(\S+\s)*(\S+)$/$2/;
	    $self->{$attrs[$i]} = $attrs[$i+1];
	}
    }
}

1;

