# --------------------------------------------------------------------------
###
#
# Copyright (c) Ensim Corporation 2000, 2001   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
# $Id: Zone_TSIG.pm,v 1.3 2002/02/22 21:24:51 mansoor Exp $
# $Name:  $
# --------------------------------------------------------------------------

package Zone_TSIG;

use strict;
use IO::File;
use File::Basename;
use File::Copy;
require Exporter;

our @ISA = qw (Exporter);
our @EXPORT_OK = qw (getKeyNameForZone setKeyNameForZone 
		     getTSIGStorageDir getWPDefaultKeyID);

use constant TSIG_STORAGE_DIR => "/etc/bind/.TSIG/";
use constant KEY_NAME_FILE => TSIG_STORAGE_DIR . "keys.index";
use constant WP_DEFAULT_KEY_ID => "wp_default_key.";

use lib ($ENV{OCW_SVCPATH} or "/usr/lib/opcenter") . "/bind";
use lib ($ENV{OCW_SVCPATH} or "/usr/lib/opcenter") . "/cmdline_common";

use ERRORS;
use Carper;

sub getWPDefaultKeyID() {
    return WP_DEFAULT_KEY_ID;
}

sub getTSIGStorageDir () {
    return TSIG_STORAGE_DIR;
}

sub getZoneTSIGPrivateKeyFile ($) {
    my $input_fh = new IO::File (KEY_NAME_FILE, 'r');
    if (! defined $input_fh) {
        $cerr += $E_UNABLEACCESSFILE and $cerr += { file => KEY_NAME_FILE } ;
	return "Unable to access " . KEY_NAME_FILE;
    }

    my $keyname = <$input_fh>;

    return TSIG_STORAGE_DIR . "$keyname.private";
}

sub setZoneTSIG ($$) {
    my $zone = shift;
    my $keyname = shift;
	
    ###
    # currently, we use one key for every zone under WP managment.
    # so, the first argument is not used.
    ###

    my $output_fh = new IO::File ('>' . KEY_NAME_FILE);
    chmod 0600, KEY_NAME_FILE;

    if (! defined $output_fh) {
        $cerr += $E_UNABLEOPENFILE and $cerr += { file => KEY_NAME_FILE } ;
	return "Unable to open " . KEY_NAME_FILE;
    }

    print $output_fh $keyname;
    if (!$output_fh->close()) {
        $cerr += $E_UNABLEUPDATEFILE and $cerr += { file => KEY_NAME_FILE } ;
	return "Unable to update " . KEY_NAME_FILE;
    }

    return;
}

1;
