import Acquisition

class BasicUser(Acquisition.Implicit):
    def __init__(self, name, password, roles, domains):
        self.name = name
        self.__ = password
        self.roles = tuple(list(roles) + ['Anonymous'])
        self.domains = domains

    def getRoles(self):
        return tuple(self.roles)

    def getRolesInContext(self, object):
        name = self.getUserName()
        roles = self.getRoles()
        object = getattr(object,'aq_inner', object)
        while 1:
            inner = getattr(object, 'aq_inner', object)
            parent = getattr(inner, 'aq_parent', None)
            if parent is not None:
                object = parent
                continue
            if hasattr(object, 'im_self'):
                object = object.im_self
                object = getattr(object, 'aq_inner', object)
                continue
            break
        roles = list(roles)
        return roles

    def getUserName(self):
        return self.name
    
    def has_role(self, roles, object=None):
        if object is not None:
            user_roles = self.getRolesInContext(object)
        else:
            user_roles = self.getRoles()
        print user_roles, object
        for role in roles:
            if role in user_roles:
                return 1
        return 0

    def allowed(self, object, object_roles=None):
        if object_roles is None or 'Anonymous' in object_roles:
            return 1
        usr_roles = self.getRolesInContext(object)
        for role in object_roles:
            if role in usr_roles:
                ufolder = getattr(self, 'aq_parent', None)
                ucontext = getattr(ufolder, 'aq_parent', None)
                if ucontext is not None:
                    if object is None:
                        return 1
                    if not hasattr(object, 'aq_inContextOf'):
                        if hasattr(object, 'im_self'):
                            object=object.im_self
                        if not hasattr(object, 'aq_inContextOf'):
                            return None
                    if not object.aq_inContextOf(ucontext, 1):
                        if 'Shared' in object_roles:
                            object_roles=self._shared_roles(object)
                            if 'Anonymous' in object_roles: return 1
                        return None
                return 1
        return None
    
class User(BasicUser):
    pass

class BasicUserFolder(Acquisition.Implicit):
    pass

nobody = User('Anonymous User', '', ('Anonymous',), [])
