errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 8

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "enabled"; enabled = 0L
options[1] = "aliases"; aliases = 1L

ALIAS_LOWER = (8L << 56) | (aliases << 48) | 0; errors[(8L << 56) | (aliases << 48) | 0] = "Upper case letters in alias name %(alias)s were converted to lower case."
DOMAIN_EXISTS = (8L << 56) | (aliases << 48) | 1; errors[(8L << 56) | (aliases << 48) | 1] = "Domain name %(alias)s already exists."
ALIAS_NAME_IS_HOST = (8L << 56) | (aliases << 48) | 2; errors[(8L << 56) | (aliases << 48) | 2] = "The domain %(domain)s is identical to the hosting computer's hostname."
ALIAS_NAME_INVALID = (8L << 56) | (aliases << 48) | 3; errors[(8L << 56) | (aliases << 48) | 3] = "The domain %(domain)s is not in valid format."
ALIAS_TOO_LONG = (8L << 56) | (aliases << 48) | 4; errors[(8L << 56) | (aliases << 48) | 4] = "The domain %(domain)s is too long."
ALIAS_SUFFIX_LOWER = (8L << 56) | (aliases << 48) | 5; errors[(8L << 56) | (aliases << 48) | 5] = "Upper case letters in domain suffix %(alias)s were converted to lower case."
ALIAS_SUFFIX_DOT = (8L << 56) | (aliases << 48) | 6; errors[(8L << 56) | (aliases << 48) | 6] = "The domain suffix %(suffix)s must begin with a period."
ALIAS_SUFFIX_NAME_INVALID = (8L << 56) | (aliases << 48) | 7; errors[(8L << 56) | (aliases << 48) | 7] = "The domain suffix %(suffix)s is not in valid format."
ALIAS_SUFFIX_TOO_LONG = (8L << 56) | (aliases << 48) | 8; errors[(8L << 56) | (aliases << 48) | 8] = "The domain suffix %(suffix)s is too long."
ALIAS_IS_PRIMARY_DOMAIN = (8L << 56) | (aliases << 48) | 9; errors[(8L << 56) | (aliases << 48) | 9] = "Domain name %(alias)s duplicates the primary domain."
ALIAS_BADCHARS = (8L << 56) | (aliases << 48) | 10; errors[(8L << 56) | (aliases << 48) | 10] = "Alias %(alias)s contains invalid characters: %(badchars)s"
UNABLE_RESERVE_ALIAS = (8L << 56) | (aliases << 48) | 11; errors[(8L << 56) | (aliases << 48) | 11] = "Unable to reserve the domain alias '%(pattern)s', because it conflicts with '%(conflict)s', which is a %(kind)s that belongs to %(reservedby)s."
