errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 11

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "webserver"; webserver = 0L
options[1] = "required_jail"; required_jail = 1L

WEBSERVER_NAME_LOWER = (11L << 56) | (webserver << 48) | 0; errors[(11L << 56) | (webserver << 48) | 0] = "Upper case letters in web server name %(server)s were converted to lower case."
WEBSERVER_NAME_IS_HOST = (11L << 56) | (webserver << 48) | 1; errors[(11L << 56) | (webserver << 48) | 1] = "The web server name is identical to the hosting computer's hostname."
WEBSERVER_NAME_INVALID = (11L << 56) | (webserver << 48) | 2; errors[(11L << 56) | (webserver << 48) | 2] = "The web server name is not in valid format."
WEBSERVER_TOO_LONG = (11L << 56) | (webserver << 48) | 3; errors[(11L << 56) | (webserver << 48) | 3] = "The web server name is too long."
WEBPREFIX_NAME_LOWER = (11L << 56) | (webserver << 48) | 4; errors[(11L << 56) | (webserver << 48) | 4] = "Upper case letters in web server prefix %(server)s were converted to lower case."
WEBPREFIX_DOT = (11L << 56) | (webserver << 48) | 5; errors[(11L << 56) | (webserver << 48) | 5] = "The web server prefix must end with a period."
WEBPREFIX_NAME_INVALID = (11L << 56) | (webserver << 48) | 6; errors[(11L << 56) | (webserver << 48) | 6] = "The web server prefix is not in valid format."
WEBPREFIX_TOO_LONG = (11L << 56) | (webserver << 48) | 7; errors[(11L << 56) | (webserver << 48) | 7] = "The web server prefix is too long."
WEBSERVER_EXISTS = (11L << 56) | (webserver << 48) | 8; errors[(11L << 56) | (webserver << 48) | 8] = "The web server name %(server)s is already in use."
WEBSERVER_BADCHARS = (11L << 56) | (webserver << 48) | 9; errors[(11L << 56) | (webserver << 48) | 9] = "The web server name %(webserver)s contains invalid characters: %(badchars)s"
UNABLE_RESERVE_WEBSERVER = (11L << 56) | (webserver << 48) | 10; errors[(11L << 56) | (webserver << 48) | 10] = "Unable to reserve the web server name '%(pattern)s', because it conflicts with '%(conflict)s', which is a %(kind)s that belongs to %(reservedby)s."
REQUIRED_JAIL_NAN = (11L << 56) | (required_jail << 48) | 11; errors[(11L << 56) | (required_jail << 48) | 11] = "Allow High Security Sites Only is not a number."
RESELLER_REQUIRES_APACHE_JAILED = (11L << 56) | (required_jail << 48) | 12; errors[(11L << 56) | (required_jail << 48) | 12] = "With Apache enabled, High Security must be enabled.  Either disable apache or enable High Security."
RESELLER_HAS_NON_JAILED_SITES = (11L << 56) | (required_jail << 48) | 13; errors[(11L << 56) | (required_jail << 48) | 13] = "Apache validation: Reseller %(username)s has sites without high security.  Please ensure all the reseller's sites have been set to High Security mode before enabling this option."

MAKE_INCLUDE_DIR = ((11L << 56) | (255L << 48)) | 0; errors[((11L << 56) | (255L << 48)) | 0] = "Failed to create configuration directory %(file)s. Error is %(errno)d : %(errstr)s"
CONF_DATA_UNAVAILABLE = ((11L << 56) | (255L << 48)) | 1; errors[((11L << 56) | (255L << 48)) | 1] = "Could not read configuration for service %(conf)s."
ADMIN_LOOKUP = ((11L << 56) | (255L << 48)) | 2; errors[((11L << 56) | (255L << 48)) | 2] = "Unable to locate site administrator information in password database."
CANNOT_CHMOD_HTML = ((11L << 56) | (255L << 48)) | 3; errors[((11L << 56) | (255L << 48)) | 3] = "Unable to set permissions on document root path %(path)s. Error is %(errno)d : %(errstr)s"
VIRTHOST_CONTAINER = ((11L << 56) | (255L << 48)) | 4; errors[((11L << 56) | (255L << 48)) | 4] = "An error occurred while writing the Apache virtualhosting container. File %(file)s. Error is %(errno)d : %(errstr)s"
VIRTHOST_CONTAINER_CLOSE = ((11L << 56) | (255L << 48)) | 5; errors[((11L << 56) | (255L << 48)) | 5] = "An error occurred while closing the Apache virtualhosting container after writing. File %(file)s. Error is %(errno)d : %(errstr)s"
RM_INCLUDE_DIR = ((11L << 56) | (255L << 48)) | 6; errors[((11L << 56) | (255L << 48)) | 6] = "Failed to remove configuration include directory %(file)s. Error is %(errno)d : %(errstr)s"
RM_CONFIG = ((11L << 56) | (255L << 48)) | 7; errors[((11L << 56) | (255L << 48)) | 7] = "Failed to remove virtualhosting container %(file)s. Error is %(errno)d : %(errstr)s"
REMOVE_WEBSITEHTML_LINK = ((11L << 56) | (255L << 48)) | 8; errors[((11L << 56) | (255L << 48)) | 8] = "Could not remove HTML symlink. File %(file)s. Error is %(errno)d : %(errstr)s"
ADD_WEBSITEHTML_LINK = ((11L << 56) | (255L << 48)) | 9; errors[((11L << 56) | (255L << 48)) | 9] = "Could not add HTML symlink. File %(file)s. Error is %(errno)d : %(errstr)s"
REMOVE_LEGACYHTML_LINK = ((11L << 56) | (255L << 48)) | 10; errors[((11L << 56) | (255L << 48)) | 10] = "Could not remove legacy HTML symlink. File %(file)s. Error is %(errno)d : %(errstr)s"
ADD_LEGACYHTML_LINK = ((11L << 56) | (255L << 48)) | 11; errors[((11L << 56) | (255L << 48)) | 11] = "Could not add legacy HTML symlink. File %(file)s. Error is %(errno)d : %(errstr)s"
COPY_INDEX_HTML = ((11L << 56) | (255L << 48)) | 12; errors[((11L << 56) | (255L << 48)) | 12] = "Could not copy default index file from %(from)s to %(to)s. Error is %(errno)d : %(errstr)s"
BUILD_DOMAIN_SITE_PREVIEW_MAP = ((11L << 56) | (255L << 48)) | 13; errors[((11L << 56) | (255L << 48)) | 13] = "Warnings encountered while building the domain preview map. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
APACHE_DOMAINPREVIEWPATH_RMTREE = ((11L << 56) | (255L << 48)) | 14; errors[((11L << 56) | (255L << 48)) | 14] = "Could not remove domain preview includes directory. File %(file)s. Error is %(errno)d : %(errstr)s"
DB_REMOVE_OLD_APACHE = ((11L << 56) | (255L << 48)) | 15; errors[((11L << 56) | (255L << 48)) | 15] = "Failed to remove old site apache config from database. DBERR: %(dberrstr)s"
DB_ADD_APACHE = ((11L << 56) | (255L << 48)) | 16; errors[((11L << 56) | (255L << 48)) | 16] = "Failed to add site apache config to database. DBERR: %(dberrstr)s"
DB_UPDATE_APACHE = ((11L << 56) | (255L << 48)) | 17; errors[((11L << 56) | (255L << 48)) | 17] = "Failed to update site apache config in database. DBERR: %(dberrstr)s"
APACHE_DOMAINPREVIEW_REMOVE_CONFPATH = ((11L << 56) | (255L << 48)) | 18; errors[((11L << 56) | (255L << 48)) | 18] = "Could not remove domain preview conf file. File %(file)s. Error is %(errno)d : %(errstr)s"
APACHE_ISBASIC = ((11L << 56) | (255L << 48)) | 19; errors[((11L << 56) | (255L << 48)) | 19] = "Webppliance Basic supports Low Security only"
APACHE_PORTCONF_READ_FAIL = ((11L << 56) | (255L << 48)) | 20; errors[((11L << 56) | (255L << 48)) | 20] = "Failed to read the apache port configuration file. Error is %(errstr)s."
APACHE_PORTUPDATE_CONF_FAIL = ((11L << 56) | (255L << 48)) | 21; errors[((11L << 56) | (255L << 48)) | 21] = "Failed to update the apache port in the configuration file. Error is %(errstr)s."
APACHE_PORTUPDATE_SITECONF_FAIL = ((11L << 56) | (255L << 48)) | 22; errors[((11L << 56) | (255L << 48)) | 22] = "Site conf update failed. Error is %(errstr)s."
APACHE_INVALID_PORTNO1 = ((11L << 56) | (255L << 48)) | 23; errors[((11L << 56) | (255L << 48)) | 23] = "Cannot use the port numbers below 1024 as they are reserved for system."
APACHE_INVALID_PORTNO2 = ((11L << 56) | (255L << 48)) | 24; errors[((11L << 56) | (255L << 48)) | 24] = "The port number for %(inputstr)s contains invalid characters."
APACHE_INVALID_PORTNO3 = ((11L << 56) | (255L << 48)) | 25; errors[((11L << 56) | (255L << 48)) | 25] = "The port number for %(inputstr)s exceeds the allowed limit."
APACHE_INVALID_PORTNO4 = ((11L << 56) | (255L << 48)) | 26; errors[((11L << 56) | (255L << 48)) | 26] = "The port number for %(inputstr)s cannot be empty."
APACHE_INVALID_PORTNO5 = ((11L << 56) | (255L << 48)) | 27; errors[((11L << 56) | (255L << 48)) | 27] = "Duplicate port numbers not allowed."
APACHE_LOGCONFIG_INPUT_EMPTY = ((11L << 56) | (255L << 48)) | 28; errors[((11L << 56) | (255L << 48)) | 28] = "The Log Analaysis cannot be empty."
APACHE_UNKNOWN_VER = ((11L << 56) | (255L << 48)) | 29; errors[((11L << 56) | (255L << 48)) | 29] = "Unknown Apache Webserver Version"
APACHE_CONF_ACCESS_ERROR = ((11L << 56) | (255L << 48)) | 30; errors[((11L << 56) | (255L << 48)) | 30] = "Unable to access %(file)s Error: %(errstr)s"
APACHE_CONF_WRITE_ERROR = ((11L << 56) | (255L << 48)) | 31; errors[((11L << 56) | (255L << 48)) | 31] = "Unable to modify the Webserver configuration %(file)s Error:%(errstr)s"
APACHE_RESTART = ((11L << 56) | (255L << 48)) | 32; errors[((11L << 56) | (255L << 48)) | 32] = "If you modify the settings of a Web Server, you must restart that Web Server."
APACHE_PORT_NOT_FOUND = ((11L << 56) | (255L << 48)) | 33; errors[((11L << 56) | (255L << 48)) | 33] = "Cannot find the port entry to be updated. Failed to update the port in the configuration file %(errstr)s."
APACHE_INPUT_PARAMS_NOT_FOUND = ((11L << 56) | (255L << 48)) | 34; errors[((11L << 56) | (255L << 48)) | 34] = "Input parameters '%(errstr)s' required for updating ports not available."
APACHE_PORTUPDATE_FRONTPAGE_FAIL = ((11L << 56) | (255L << 48)) | 35; errors[((11L << 56) | (255L << 48)) | 35] = "Frontpage update failed. Error is %(errstr)s."
APACHE_PORTUPDATE_FRONTPAGECNF_FAIL = ((11L << 56) | (255L << 48)) | 36; errors[((11L << 56) | (255L << 48)) | 36] = "Failed to create new cnf files for updated ports. Error is %(errstr)s."
APACHE_PORTUPDATE_WRITE_FAIL = ((11L << 56) | (255L << 48)) | 37; errors[((11L << 56) | (255L << 48)) | 37] = "Failed to write the updated conf files to disk. Error is %(errstr)s."
MAX_CLIENTS = ((11L << 56) | (255L << 48)) | 38; errors[((11L << 56) | (255L << 48)) | 38] = "MaxClients was set to 2048, because this is the hard limit of the server."
INVALID_SERVER_NAME = ((11L << 56) | (255L << 48)) | 39; errors[((11L << 56) | (255L << 48)) | 39] = "INVALID_SERVER_NAME: %(name)s"
DUPLICATE_PORT = ((11L << 56) | (255L << 48)) | 40; errors[((11L << 56) | (255L << 48)) | 40] = "One of the new ports specified is already being used. Please choose another port."
APACHE_RESTART2 = ((11L << 56) | (255L << 48)) | 41; errors[((11L << 56) | (255L << 48)) | 41] = "If you swap the Test and Production Web Servers, stop both the Web Servers and then restart each Server for the change to take effect."
