errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 3

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
CREATE_ZONE_FAILED = ((3L << 56) | (255L << 48)) | 1; errors[((3L << 56) | (255L << 48)) | 1] = "Failed to create zone %(zone)s.\nOriginal DNS Backend Message : %(reason)s"
REMOVE_ZONE_FAILED = ((3L << 56) | (255L << 48)) | 2; errors[((3L << 56) | (255L << 48)) | 2] = "Failed to remove zone %(zone)s.\nOriginal DNS Backend Message : %(reason)s"
MOVE_ZONE_FAILED = ((3L << 56) | (255L << 48)) | 3; errors[((3L << 56) | (255L << 48)) | 3] = "Failed to move zone from %(oldzone)s to %(newzone)s.\nOriginal DNS Backend Message : %(reason)s"


ADD_A_FAILED = ((3L << 56) | (255L << 48)) | 10; errors[((3L << 56) | (255L << 48)) | 10] = "Failed to add A record %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DEL_A_FAILED = ((3L << 56) | (255L << 48)) | 11; errors[((3L << 56) | (255L << 48)) | 11] = "Failed to remove A record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"

ADD_CNAME_FAILED = ((3L << 56) | (255L << 48)) | 12; errors[((3L << 56) | (255L << 48)) | 12] = "Failed to add CNAME record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DEL_CNAME_FAILED = ((3L << 56) | (255L << 48)) | 13; errors[((3L << 56) | (255L << 48)) | 13] = "Failed to remove CNAME record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"

ADD_MX_FAILED = ((3L << 56) | (255L << 48)) | 14; errors[((3L << 56) | (255L << 48)) | 14] = "Failed to add MX record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DEL_MX_FAILED = ((3L << 56) | (255L << 48)) | 15; errors[((3L << 56) | (255L << 48)) | 15] = "Failed to remove MX record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"

ADD_NS_FAILED = ((3L << 56) | (255L << 48)) | 16; errors[((3L << 56) | (255L << 48)) | 16] = "Failed to add NS record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DEL_NS_FAILED = ((3L << 56) | (255L << 48)) | 17; errors[((3L << 56) | (255L << 48)) | 17] = "Failed to remove NS record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"

ADD_PTR_FAILED = ((3L << 56) | (255L << 48)) | 18; errors[((3L << 56) | (255L << 48)) | 18] = "Failed to add PTR record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DEL_PTR_FAILED = ((3L << 56) | (255L << 48)) | 19; errors[((3L << 56) | (255L << 48)) | 19] = "Failed to remove PTR record, %(rrstr)s.\nOriginal DNS Backend Message : %(reason)s"
DISABLE_WARNING = ((3L << 56) | (255L << 48)) | 20; errors[((3L << 56) | (255L << 48)) | 20] = "Please use the Bind DNS Manager to edit/delete the zone for this domain."
SET_SOA_FAILED = ((3L << 56) | (255L << 48)) | 21; errors[((3L << 56) | (255L << 48)) | 21] = "Failed to set SOA record, %(rrstr)s : %(reason)s"

SET_VIRTUAL_FAILED = ((3L << 56) | (255L << 48)) | 22; errors[((3L << 56) | (255L << 48)) | 22] = "Failed to set virtual DNS, %(hostname)s %(ip)s: %(reason)s"
ADD_SLAVE_FAILED = ((3L << 56) | (255L << 48)) | 23; errors[((3L << 56) | (255L << 48)) | 23] = "Failed to add slave server, %(hostname)s: %(reason)s"
DEL_SLAVE_FAILED = ((3L << 56) | (255L << 48)) | 24; errors[((3L << 56) | (255L << 48)) | 24] = "Failed to delete slave server, %(hostname)s: %(reason)s"
