errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 56

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
SCRIPTSMGR_NOT_ENABLED = ((56L << 56) | (255L << 48)) | 0; errors[((56L << 56) | (255L << 48)) | 0] = "Ensim Powertools support is not enabled for this site."
INVALID_INSTANCE_ID = ((56L << 56) | (255L << 48)) | 1; errors[((56L << 56) | (255L << 48)) | 1] = "A matching instance of this script could not be found."
NONUNIQUE_INSTANCE_CONF = ((56L << 56) | (255L << 48)) | 2; errors[((56L << 56) | (255L << 48)) | 2] = "Multiple instances of this script were found that matched the given description."
INSTANCE_EXISTS = ((56L << 56) | (255L << 48)) | 3; errors[((56L << 56) | (255L << 48)) | 3] = "One or more instances matching this description already exist."
DSP_NOT_DEPLOYABLE = ((56L << 56) | (255L << 48)) | 4; errors[((56L << 56) | (255L << 48)) | 4] = "This site is not allowed to deploy this script package."
GLOBAL_DSP_NOT_DEPLOYABLE = ((56L << 56) | (255L << 48)) | 5; errors[((56L << 56) | (255L << 48)) | 5] = "This script package has been disabled by the appliance administrator."
DSP_NOT_FOUND = ((56L << 56) | (255L << 48)) | 6; errors[((56L << 56) | (255L << 48)) | 6] = "This script package does not exist."
DSP_INSTALL_SUCCESSFUL = ((56L << 56) | (255L << 48)) | 7; errors[((56L << 56) | (255L << 48)) | 7] = "The installation was successful."
DSP_RECONFIGURE_SUCCESSFUL = ((56L << 56) | (255L << 48)) | 8; errors[((56L << 56) | (255L << 48)) | 8] = "The reconfiguration was successful."
DSP_UPGRADE_SUCCESSFUL = ((56L << 56) | (255L << 48)) | 9; errors[((56L << 56) | (255L << 48)) | 9] = "The upgrade was successful."
DSP_STATUS_MSG = ((56L << 56) | (255L << 48)) | 10; errors[((56L << 56) | (255L << 48)) | 10] = "%(dsp_status_msg)s"
DSP_NOT_INSTALLED = ((56L << 56) | (255L << 48)) | 11; errors[((56L << 56) | (255L << 48)) | 11] = "This script package is not installed."
TRACEBACK_ERROR = ((56L << 56) | (255L << 48)) | 12; errors[((56L << 56) | (255L << 48)) | 12] = "Traceback occurred: %(traceback)s"
PT_LICENSE_INVALID = ((56L << 56) | (255L << 48)) | 13; errors[((56L << 56) | (255L << 48)) | 13] = "Power Tools License is not valid. Please install a valid Ensim Power Tools license."
PT_LICENSE_NOTINSTALLED = ((56L << 56) | (255L << 48)) | 14; errors[((56L << 56) | (255L << 48)) | 14] = "Power Tools License is not installed.  Please install a Power Tools License"
MULTI_INSTANCE_USERNAME_CHANGE = ((56L << 56) | (255L << 48)) | 15; errors[((56L << 56) | (255L << 48)) | 15] = "There is a %(longname)s %(version)s (%(dapiversion)s-%(dapirelease)s) installation that also resides at this installation location (%(install_loc)s) and is currently owned by %(username)s. This application may stop working until its owner is also changed to %(newuser)s."
MULTI_INSTANCE_URL_USERNAME_CHANGE = ((56L << 56) | (255L << 48)) | 16; errors[((56L << 56) | (255L << 48)) | 16] = "There is a %(longname)s %(version)s (%(dapiversion)s-%(dapirelease)s) installation that also resides at this installation location (%(install_loc)s; accessible via the URL %(url_loc)s) and is currently owned by %(username)s. This application may stop working until its owner is also changed to %(newuser)s."
EXPORTED_DSP_DBNAME_CONFLICT = ((56L << 56) | (255L << 48)) | 17; errors[((56L << 56) | (255L << 48)) | 17] = "There is an existing Power Tool installation located in %(install_loc)s that already uses the database %(dbname)s. The archived Power Tool can not be restored."
EXPORTED_DSP_INSTALL_LOC_CONFLICT = ((56L << 56) | (255L << 48)) | 18; errors[((56L << 56) | (255L << 48)) | 18] = "There is an existing Power Tool installation located in %(install_loc)s. The archived Power Tool can not be restored."
EXPORTED_DSP_NOT_INSTALLED = ((56L << 56) | (255L << 48)) | 19; errors[((56L << 56) | (255L << 48)) | 19] = "The Power Tool %(tool)s is not installed. The archived Power Tool can not be restored."
