errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 5

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "admin"; admin = 0L
options[1] = "domain"; domain = 1L
options[2] = "admin_user"; admin_user = 2L
options[3] = "passwd1"; passwd1 = 3L
options[4] = "passwd2"; passwd2 = 4L
options[5] = "email"; email = 5L
options[6] = "cpasswd"; cpasswd = 6L
options[7] = "tpasswd"; tpasswd = 7L
options[8] = "security"; security = 8L

INVALID_CHARS_IN_DOMAIN = (5L << 56) | (domain << 48) | 0; errors[(5L << 56) | (domain << 48) | 0] = "Domain name contains invalid characters: %(domain)s"
DOMAIN_TOO_LONG = (5L << 56) | (domain << 48) | 1; errors[(5L << 56) | (domain << 48) | 1] = "Domain name exceeds 64 characters: %(domain)s"
DOMAIN_NAME_LOWER = (5L << 56) | (domain << 48) | 2; errors[(5L << 56) | (domain << 48) | 2] = "Upper case letters in domain name %(domain)s were converted to lower case."
USER_NAME_LOWER = (5L << 56) | (admin_user << 48) | 3; errors[(5L << 56) | (admin_user << 48) | 3] = "Upper case letters in user name %(user)s were converted to lower case."
INVALID_DOMAIN_NAME = (5L << 56) | (domain << 48) | 4; errors[(5L << 56) | (domain << 48) | 4] = "Domain name %(domain)s is not in valid format."
DOMAIN_EXISTS = (5L << 56) | (domain << 48) | 5; errors[(5L << 56) | (domain << 48) | 5] = "Domain name %(domain)s already exists."
INVALID_USERNAME = (5L << 56) | (admin_user << 48) | 6; errors[(5L << 56) | (admin_user << 48) | 6] = "User name %(admin_user)s is invalid."
INVALID_CRYPTED_PASSWORD = (5L << 56) | (cpasswd << 48) | 7; errors[(5L << 56) | (cpasswd << 48) | 7] = "The crypted password is invalid."
INVALID_PASSWORD = (5L << 56) | (tpasswd << 48) | 8; errors[(5L << 56) | (tpasswd << 48) | 8] = "The password contains invalid characters."
PASSWD1_PASSWD2_MISCOMPARE = (5L << 56) | (passwd1 << 48) | 9; errors[(5L << 56) | (passwd1 << 48) | 9] = "Passwords do not match."
PASSWD2_PASSWD1_MISCOMPARE = (5L << 56) | (passwd2 << 48) | 10; errors[(5L << 56) | (passwd2 << 48) | 10] = "Passwords do not match."
MUST_SPECIFY_PASSWORD1 = (5L << 56) | (passwd1 << 48) | 11; errors[(5L << 56) | (passwd1 << 48) | 11] = "Password must be specified."
MUST_SPECIFY_PASSWORD2 = (5L << 56) | (passwd2 << 48) | 12; errors[(5L << 56) | (passwd2 << 48) | 12] = "Password must be specified."
INVALID_PASSWORD = (5L << 56) | (passwd1 << 48) | 13; errors[(5L << 56) | (passwd1 << 48) | 13] = "The password contains invalid characters."
INVALID_PASSWORD = (5L << 56) | (passwd2 << 48) | 14; errors[(5L << 56) | (passwd2 << 48) | 14] = "The password contains invalid characters."
INVALID_EMAIL = (5L << 56) | (email << 48) | 15; errors[(5L << 56) | (email << 48) | 15] = "Invalid email address %(email)s."
DOMAIN_IS_HOST_NAME = (5L << 56) | (domain << 48) | 16; errors[(5L << 56) | (domain << 48) | 16] = "Domain %(domain)s conflicts with the hosting computer's name."
DOMAIN_TOO_LONG = (5L << 56) | (domain << 48) | 17; errors[(5L << 56) | (domain << 48) | 17] = "Domain %(domain)s is too long."
USER_NAME_BLANK = (5L << 56) | (admin_user << 48) | 18; errors[(5L << 56) | (admin_user << 48) | 18] = "Administrator user name is empty"
BLANK_EMAIL = (5L << 56) | (email << 48) | 19; errors[(5L << 56) | (email << 48) | 19] = "Email address is empty."
BLANK_PASSWORD1 = (5L << 56) | (passwd1 << 48) | 20; errors[(5L << 56) | (passwd1 << 48) | 20] = "Password is empty."
BLANK_PASSWORD2 = (5L << 56) | (passwd2 << 48) | 21; errors[(5L << 56) | (passwd2 << 48) | 21] = "Confirm Password is empty."
BLANK_DOMAIN_NAME = (5L << 56) | (domain << 48) | 22; errors[(5L << 56) | (domain << 48) | 22] = "Site Name is empty."
USER_NAME_BADCHARS = (5L << 56) | (admin_user << 48) | 23; errors[(5L << 56) | (admin_user << 48) | 23] = "Administrator Name contains bad characters: %(badchars)s"
EMAIL_BADCHARS = (5L << 56) | (email << 48) | 24; errors[(5L << 56) | (email << 48) | 24] = "Administrator Email contains bad characters: %(badchars)s"
DOMAIN_BADCHARS = (5L << 56) | (domain << 48) | 25; errors[(5L << 56) | (domain << 48) | 25] = "Site Name contains bad characters: %(badchars)s"
PASSWD1_BADCHARS = (5L << 56) | (passwd1 << 48) | 26; errors[(5L << 56) | (passwd1 << 48) | 26] = "Crypted password contains bad characters: %(badchars)s"
PASSWD2_BADCHARS = (5L << 56) | (passwd2 << 48) | 27; errors[(5L << 56) | (passwd2 << 48) | 27] = "Crypted password contains bad characters: %(badchars)s"
USER_NAME_TOO_LONG = (5L << 56) | (admin_user << 48) | 28; errors[(5L << 56) | (admin_user << 48) | 28] = "Administrator user name is too long. It should contain at most %(limit)s characters"
CHANGE_DISABLED_ADMIN = (5L << 56) | (admin_user << 48) | 29; errors[(5L << 56) | (admin_user << 48) | 29] = "Administrator user name may not be changed while a site is suspended"
USERNAME_EXISTS = (5L << 56) | (admin_user << 48) | 30; errors[(5L << 56) | (admin_user << 48) | 30] = "Administrator user name %(admin_user)s already exists (legacy mode is currently enabled)."
USERNAME_DBERR = (5L << 56) | (admin_user << 48) | 31; errors[(5L << 56) | (admin_user << 48) | 31] = "Database error occured while validating admin user (legacy mode is currently enabled). DB error: %(dberrstr)s"
USER_EXISTS_IN_DOMAIN = (5L << 56) | (admin_user << 48) | 32; errors[(5L << 56) | (admin_user << 48) | 32] = "The username %(user)s is already in use within the domain"
ADMIN_IS_NOT_UNIQUE = (5L << 56) | (admin_user << 48) | 33; errors[(5L << 56) | (admin_user << 48) | 33] = "The administrator username %(admin)s is already in use by another domain"
NO_SECURITY_LEVEL = (5L << 56) | (security << 48) | 34; errors[(5L << 56) | (security << 48) | 34] = "No Security Level Chosen"
UNABLE_RESERVE_DOMAIN = (5L << 56) | (domain << 48) | 35; errors[(5L << 56) | (domain << 48) | 35] = "Unable to reserve the domain name '%(pattern)s', because it conflicts with '%(conflict)s', which is a %(kind)s that belongs to %(reservedby)s."

CREATE_WPSETUPFILE = ((5L << 56) | (255L << 48)) | 0; errors[((5L << 56) | (255L << 48)) | 0] = "Failed to create webppliance setup files (creating file %(dstfile)s from %(srcfile)s)"
CREATE_SYMLINKS = ((5L << 56) | (255L << 48)) | 1; errors[((5L << 56) | (255L << 48)) | 1] = "Failed to create symlinks for domain filesystem. File %(file)s. Error is %(errno)d : %(errstr)s"
CHMOD = ((5L << 56) | (255L << 48)) | 2; errors[((5L << 56) | (255L << 48)) | 2] = "Failed to modify permissions of file. Error is %(errno)d : %(errstr)s"
CREATE_CRON_FILE = ((5L << 56) | (255L << 48)) | 3; errors[((5L << 56) | (255L << 48)) | 3] = "Failed to create cron file %(file)s in directory %(dir)s. Error is %(errno)d : %(errstr)s"
UNKNOWN_ADMIN_USER = ((5L << 56) | (255L << 48)) | 4; errors[((5L << 56) | (255L << 48)) | 4] = "Could not locate administrative user %(admin)s."
ADMIN_USER_ADD = ((5L << 56) | (255L << 48)) | 5; errors[((5L << 56) | (255L << 48)) | 5] = "Failed to add administrator user %(admin)s to domain. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
ADMIN_GROUP_ADD = ((5L << 56) | (255L << 48)) | 5; errors[((5L << 56) | (255L << 48)) | 5] = "Failed to add administrator group %(admin)s to domain. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
CREATE_ALIASES = ((5L << 56) | (255L << 48)) | 6; errors[((5L << 56) | (255L << 48)) | 6] = "Failed to set initial aliases. Error is %(errno)d : %(errstr)s"
RENAME_SYMLINK = ((5L << 56) | (255L << 48)) | 7; errors[((5L << 56) | (255L << 48)) | 7] = "Failed to rename domain symlink from %(from)s to %(to)s. Error is %(errno)d : %(errstr)s for file %(file)s"
MODIFY_ADMIN = ((5L << 56) | (255L << 48)) | 8; errors[((5L << 56) | (255L << 48)) | 8] = "Failed to change administrator user name and password. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
MODIFY_ADMIN_NAME = ((5L << 56) | (255L << 48)) | 9; errors[((5L << 56) | (255L << 48)) | 9] = "Failed to change administrator user name. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
MODIFY_ADMIN_PASSWD = ((5L << 56) | (255L << 48)) | 10; errors[((5L << 56) | (255L << 48)) | 10] = "Failed to change administrator user name. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
REMOVE_SYMLINKS = ((5L << 56) | (255L << 48)) | 11; errors[((5L << 56) | (255L << 48)) | 11] = "Failed to remove domain symbolic link %(file)s. Error is %(errno)d : %(errstr)s"
REMOVE_CRON_FILE = ((5L << 56) | (255L << 48)) | 12; errors[((5L << 56) | (255L << 48)) | 12] = "Failed to remove cron file %(file)s. Error is %(errno)d : %(errstr)s"
MODIFY_ADMIN_COMMENT = ((5L << 56) | (255L << 48)) | 13; errors[((5L << 56) | (255L << 48)) | 13] = "Failed to set site administrator's password entry comment field to domain name. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
READ_ALIASES = ((5L << 56) | (255L << 48)) | 14; errors[((5L << 56) | (255L << 48)) | 14] = "Failed to read the domain aliases file %(file)s. Error is %(errno)d : %(errstr)s"
READ_ALIASES_CLOSE = ((5L << 56) | (255L << 48)) | 15; errors[((5L << 56) | (255L << 48)) | 15] = "Failed to close the domain aliases file %(file)s after reading. Error is %(errno)d : %(errstr)s"
UPDATE_ALIASES = ((5L << 56) | (255L << 48)) | 16; errors[((5L << 56) | (255L << 48)) | 16] = "Failed to update aliases file with new site administrator name. Error is %(errno)d : %(errstr)s"
UPDATE_ALIASES_CLOSE = ((5L << 56) | (255L << 48)) | 17; errors[((5L << 56) | (255L << 48)) | 17] = "Failed to close aliases file while updating with new site administrator name. Error is %(errno)d : %(errstr)s"
UPDATE_ROOT_ALIAS = ((5L << 56) | (255L << 48)) | 18; errors[((5L << 56) | (255L << 48)) | 18] = "Could not update root alias with new site administrator name. This may be due to modifications to the alias file, and is not necessarily an error."
UPDATE_CATCHALL_ALIAS = ((5L << 56) | (255L << 48)) | 19; errors[((5L << 56) | (255L << 48)) | 19] = "Could not update catch-all alias with new site administrator name. This may be due to modifications to the alias file, and is not necessarily an error."
CREATE_LOGROTATE_FILE = ((5L << 56) | (255L << 48)) | 20; errors[((5L << 56) | (255L << 48)) | 20] = "Failed to create logrotate file %(file)s in directory %(dir)s. Error is %(errno)d : %(errstr)s"
REMOVE_LOGROTATE_FILE = ((5L << 56) | (255L << 48)) | 21; errors[((5L << 56) | (255L << 48)) | 21] = "Failed to remove logrotate file %(file)s. Error is %(errno)d : %(errstr)s"
READ_PASSWD = ((5L << 56) | (255L << 48)) | 22; errors[((5L << 56) | (255L << 48)) | 22] = "Failed to read the password file %(file)s. Error is %(errno)d : %(errstr)s"
READ_PASSWD_CLOSE = ((5L << 56) | (255L << 48)) | 23; errors[((5L << 56) | (255L << 48)) | 23] = "Failed to close the password file %(file)s after reading. Error is %(errno)d : %(errstr)s"
UPDATE_PASSWD = ((5L << 56) | (255L << 48)) | 24; errors[((5L << 56) | (255L << 48)) | 24] = "Failed to update the password file. Error is %(errno)d : %(errstr)s"
UPDATE_PASSWD_CLOSE = ((5L << 56) | (255L << 48)) | 25; errors[((5L << 56) | (255L << 48)) | 25] = "Failed to close the password file while updating. Error is %(errno)d : %(errstr)s"
POPULATE_ETC_HOSTNAME_FILE = ((5L << 56) | (255L << 48)) | 26; errors[((5L << 56) | (255L << 48)) | 26] = "Failed to populate file %(file)s. Error is %(errno)d : %(errstr)s"
LASTLOG_CREATE = ((5L << 56) | (255L << 48)) | 27; errors[((5L << 56) | (255L << 48)) | 27] = "Failed to create login-tracking file %(file)s. Error is %(errno)d : %(errstr)s"
DB_REMOVE_OLD_SITE = ((5L << 56) | (255L << 48)) | 28; errors[((5L << 56) | (255L << 48)) | 28] = "Failed to remove old site from database. DBERR: %(dberrstr)s"
DB_ADD_SITE = ((5L << 56) | (255L << 48)) | 29; errors[((5L << 56) | (255L << 48)) | 29] = "Failed to add site to database. DBERR: %(dberrstr)s"
DB_UPDATE_SITE = ((5L << 56) | (255L << 48)) | 30; errors[((5L << 56) | (255L << 48)) | 30] = "Failed to update site in database. DBERR: %(dberrstr)s"
CHANGE_ADMIN_GROUP = ((5L << 56) | (255L << 48)) | 31; errors[((5L << 56) | (255L << 48)) | 31] = "Failed to modify site administrator group. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
CHANGE_ADMIN_USER = ((5L << 56) | (255L << 48)) | 32; errors[((5L << 56) | (255L << 48)) | 32] = "Failed to modify site administrator. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
MODIFY_ADMIN_PASSWD_COMMENT = ((5L << 56) | (255L << 48)) | 33; errors[((5L << 56) | (255L << 48)) | 33] = "Failed to set the site administrator's password and comment. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error : %(stderr)s"
ENABLE_LEGACY = ((5L << 56) | (255L << 48)) | 34; errors[((5L << 56) | (255L << 48)) | 34] = "Failed to enable legacy mode.  DBERR: %(dberrstr)s"
DISABLE_LEGACY = ((5L << 56) | (255L << 48)) | 35; errors[((5L << 56) | (255L << 48)) | 35] = "Failed to disable legacy mode.  DBERR: %(dberrstr)s"
REMOVE_LEGACY_FILE = ((5L << 56) | (255L << 48)) | 36; errors[((5L << 56) | (255L << 48)) | 36] = "Failed to remove legacy flag.  ERROR: %(errmsg)s"
READ_USERINFO = ((5L << 56) | (255L << 48)) | 37; errors[((5L << 56) | (255L << 48)) | 37] = "Failed to read user information from file %(file)s. Error is %(errno)d : %(errstr)s"
READ_USERINFO_CLOSE = ((5L << 56) | (255L << 48)) | 38; errors[((5L << 56) | (255L << 48)) | 38] = "Failed to close file %(file)s. Error is %(errno)d : %(errstr)s"
UPDATE_USERINFO = ((5L << 56) | (255L << 48)) | 39; errors[((5L << 56) | (255L << 48)) | 39] = "Failed to update user information in file %(file)s. Error is %(errno)d : %(errstr)s"
UPDATE_USERINFO_CLOSE = ((5L << 56) | (255L << 48)) | 40; errors[((5L << 56) | (255L << 48)) | 40] = "Failed to close file %(file)s. Error is %(errno)d : %(errstr)s"
CHMOD_SHADOW = ((5L << 56) | (255L << 48)) | 41; errors[((5L << 56) | (255L << 48)) | 41] = "Failed to set access permissions for for shadow password file %(file)s. Error is %(errno)d : %(errstr)s"
RENAME_ADMIN_HOME = ((5L << 56) | (255L << 48)) | 42; errors[((5L << 56) | (255L << 48)) | 42] = "Failed to rename the administrator's home directory. File %(file)s. Error is %(errno)d : %(errstr)s"
CREATE_DOMAINFS_SYMLINKS = ((5L << 56) | (255L << 48)) | 43; errors[((5L << 56) | (255L << 48)) | 43] = "Failed to create symbolic link from %(from)s to %(to)s. File %(file)s. Error is %(errno)d : %(errstr)s"
CREATE_DOMAINFS_DEVICES = ((5L << 56) | (255L << 48)) | 44; errors[((5L << 56) | (255L << 48)) | 44] = "Failed to create device %(device)s. Error %(errno)d : %(errstr)s."
DB_GET_EMAIL_MAPPINGS = ((5L << 56) | (255L << 48)) | 45; errors[((5L << 56) | (255L << 48)) | 45] = "Failed to get (site, administrator, domain) mappings from database. Error: %(dberrstr)s"
CREATE_GENERICS_FILE = ((5L << 56) | (255L << 48)) | 46; errors[((5L << 56) | (255L << 48)) | 46] = "Failed to create generics mapping file. File %(file)s. Error is %(errno)d : %(errstr)s"
GENERICS_FILE_CLOSE = ((5L << 56) | (255L << 48)) | 47; errors[((5L << 56) | (255L << 48)) | 47] = "Failed to close generics mapping file. File %(file)s. Error is %(errno)d : %(errstr)s"
CREATE_GENERICS_DB = ((5L << 56) | (255L << 48)) | 48; errors[((5L << 56) | (255L << 48)) | 48] = "Failed to create generics database. Error %(errno)d.\nStandard out: %(stdout)s\nStandard Error: %(stderr)s"
WTMP_CREATE = ((5L << 56) | (255L << 48)) | 49; errors[((5L << 56) | (255L << 48)) | 49] = "Failed to create login-tracking file %(file)s. Error is %(errno)d : %(errstr)s"
UTMP_CREATE = ((5L << 56) | (255L << 48)) | 50; errors[((5L << 56) | (255L << 48)) | 50] = "Failed to create login-tracking file %(file)s. Error is %(errno)d : %(errstr)s"
DEVLOG_CREATE = ((5L << 56) | (255L << 48)) | 51; errors[((5L << 56) | (255L << 48)) | 51] = "Failed to link /dev/log to domain log file. Error is %(errno)d : %(errstr)s"
INVALID_USER_NAME = ((5L << 56) | (255L << 48)) | 52; errors[((5L << 56) | (255L << 48)) | 52] = "Invalid login name %(user)s."
SITE_CONFLICTING_SUBDOMAIN = ((5L << 56) | (255L << 48)) | 53; errors[((5L << 56) | (255L << 48)) | 53] = "A subdomain %(subdomain)s already exists within the domain %(domain)s!"
SITE_CONFLICTING_WILDCARDS = ((5L << 56) | (255L << 48)) | 54; errors[((5L << 56) | (255L << 48)) | 54] = "The domain %(domain)s has subdomain wildcards enabled. %(this)s would be treated as a subdomain for that site!"
USERNAME_CANNOT_BE_ROOT = ((5L << 56) | (255L << 48)) | 55; errors[((5L << 56) | (255L << 48)) | 55] = "Username cannot be root."
CREATE_STATS = ((5L << 56) | (255L << 48)) | 56; errors[((5L << 56) | (255L << 48)) | 56] = "Failed to create Sendmail statistics file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_LOCAL_HOST_NAMES = ((5L << 56) | (255L << 48)) | 57; errors[((5L << 56) | (255L << 48)) | 57] = "Failed to set up Sendmail local host name file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_DOMAIN_INFO_M4 = ((5L << 56) | (255L << 48)) | 58; errors[((5L << 56) | (255L << 48)) | 58] = "Failed to set up Sendmail domain information file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_DOMAIN_INFO_M4_CLOSE = ((5L << 56) | (255L << 48)) | 59; errors[((5L << 56) | (255L << 48)) | 59] = "Failed to close Sendmail domain information file %(file)s. Error is %(errno)d : %(errstr)s"
CREATE_SENDMAIL_CF = ((5L << 56) | (255L << 48)) | 60; errors[((5L << 56) | (255L << 48)) | 60] = "Failed to generate Sendmail configuration file. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
MQUEUE_CREATE = ((5L << 56) | (255L << 48)) | 61; errors[((5L << 56) | (255L << 48)) | 61] = "Failed to create site mail queue %(file)s. Error is %(errno)d : %(errstr)s"
GENERATE_SUBMIT_CF = ((5L << 56) | (255L << 48)) | 62; errors[((5L << 56) | (255L << 48)) | 62] = "Failed to generate site submit.cf file. Error: %(errno)d : %(stdout)s, %(stderr)s"
